/************************************************************************
̱ɴϢδ𴴥饹

class card
  ɤΤΤΥ饹structureǤ⽽ʬʤɡ

class card_stock
  ɤ򤿤뤿Υ饹
***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "card.h"


/*
========================================================================
ǽ: ̱ѥֹӥ롼
: n, m = ֹ
: nm礭1(n>m)ʳ0(n==m or n<m)
­: 
========================================================================
*/
int
card::compare(int n, int m)
{
	if (n < m) {
		if (n==1 && m<14) {
			return 1;
		} else {
			return 0;
		}
	}
	else if (n > m) {
		if (n<14 && m==1) {
			return 0;
		} else {
			return 1;
		}
	}
	else {
		return 0;
	}
}


card_stock::card_stock()
{
	num = alloc = 0;
	cards = NULL;
}


card_stock::~card_stock()
{
	int i;

	for(i=0; i<num; i++) {
		delete cards[i];
	}
	if (cards) {
		delete cards;
	}
}


/*
========================================================================
ǽ: ɤɲ
: _card = ɤΤ
: ʤ
­: 
========================================================================
*/
void
card_stock::add_card(card* _card)
{
	int i;
	card** new_cards;
	
	if (num==alloc) {
		new_cards = new card*[alloc + CARD_STOCK_ALLOC_STEP];
		alloc +=  CARD_STOCK_ALLOC_STEP;
		for (i=0; i<num; i++) {
			new_cards[i] = cards[i];
		}
		if (cards) delete cards;
		cards = new_cards;
	}
	cards[num++] = _card;
}


/*
========================================================================
ǽ: ɤɲ
: cs = ɥȥå
: ʤ
­: csΥɤɲä롣cs϶ˤʤ롣
========================================================================
*/
void
card_stock::add_card(card_stock* cs)
{
	int i, n;

	n = cs->getnum();
	for(i=0; i<n; i++) {
		add_card(cs->get_card(cs->show_card(0)));
	}
}


/*
========================================================================
ǽ: ɤμ(ֹ)
: n = ֹ
: ֹΥɤ̵֤NULL
­: ֤줿ɤϼ긵Ϻ
========================================================================
*/
card*
card_stock::get_card(int n)
{
	int i, j;
	card* c;
	for(i=0; i<num; i++) {
		if (cards[i]->getnum()==n) {
			c = cards[i];
			for(j=i; j<num-1; j++) {
				cards[j] = cards[j+1];
			}
			num--;
			return c;
		}
	}
	return NULL;
}


/*
========================================================================
ǽ: ɤμ(ޡֹ)
: s = ޡ
      n = ֹ
: Υɤ̵֤NULL
­: ֤줿ɤϼ긵Ϻ
========================================================================
*/
card*
card_stock::get_card(enum card_suite s, int n)
{
	card* c;
	int i, j;
	
	for(i=0; i<num; i++) {
		if (cards[i]->getsuite()==s && cards[i]->getnum()==n) {
			c = cards[i];
			for(j=i; j<num-1; j++) {
				cards[j] = cards[j+1];
			}
			num--;
			return c;
		}
	}
	return NULL;
}


/*
========================================================================
ǽ: ̵٤˼Ф
: ʤ
: ̵NULL
­: ֤줿ɤϼ긵Ϻ
========================================================================
*/
card*
card_stock::get_one()
{
	if (num<=0) return NULL;
	return cards[--num];
}


/*
========================================================================
ǽ: ɤμ(Ǥ)
: c = 
: Υɤ̵֤NULL
­: ֤줿ɤϼ긵Ϻ
========================================================================
*/
card*
card_stock::get_card(card* c)
{
	int i, j;
	
	for(i=0; i<num; i++) {
		if (cards[i]==c) {
			for(j=i; j<num-1; j++) {
				cards[j] = cards[j+1];
			}
			num--;
			return c;
		}
	}
	return NULL;
}


/*
========================================================================
ǽ: ɤ򸫤
: pos = 껥ΰ
: Υɤ̵֤NULL
­: Υ롼ǤϥɤϺʤ
========================================================================
*/
card*
card_stock::show_card(int pos)
{
	if (pos<0 || pos>=num) return NULL;
	return cards[pos];
}


/*
========================================================================
ǽ: Ȥ
: ʤ
: ʤ
­: 羮Ӥˤcard::compare()Ȥ
========================================================================
*/
void
card_stock::sort()
{
	int i, f;
	card* c;

	do {
		f = 0;
		for(i=0; i<num-1; i++) {
			if (card::compare(cards[i]->getnum(), cards[i+1]->getnum())) {
				c = cards[i];
				cards[i] = cards[i+1];
				cards[i+1] = c;
				f = 1;
			}
			else if (cards[i]->getnum()==cards[i+1]->getnum()
					 && cards[i]->getsuite() > cards[i+1]->getsuite()) {
				c = cards[i];
				cards[i] = cards[i+1];
				cards[i+1] = c;
				f = 1;
			}
		}
	} while (f);
}


/*
========================================================================
ǽ: åե뤹
: ʤ
: ʤ
­: 
========================================================================
*/
void
card_stock::shuffle()
{
	int i, j, n, m;
	card* c;

	for(j=0; j<1000; j++) {
		for(i=0; i<num; i++) {
			while(1) {
				n = rand() % num;
				m = rand() % num;
				if (n==m) continue;
				break;
			}
			c = cards[n];
			cards[n] = cards[m];
			cards[m] = c;
		}
	}
}


/*
========================================================================
ǽ: ȤΥɤɥȥå֤
: ʤ
: ʬΥɤäɥȥå
­: 
========================================================================
*/
card_stock*
card_stock::gen_all()
{
	card_stock* cs;
	card* c;
	int i;
	
	cs = new card_stock();
	for(i=1; i<=13; i++) {
		c = new card(SUITE_HEART, i);
		cs->add_card(c);
	}
	for(i=1; i<=13; i++) {
		c = new card(SUITE_CLUB, i);
		cs->add_card(c);
	}
	for(i=1; i<=13; i++) {
		c = new card(SUITE_DIA, i);
		cs->add_card(c);
	}
	for(i=1; i<=13; i++) {
		c = new card(SUITE_SPADE, i);
		cs->add_card(c);
	}
	c = new card(SUITE_NONE, 14);
	cs->add_card(c);
	return cs;
}


/*
========================================================================
ǽ: ɥȥåΥɤֹ̤˿
: ʤ
: ʤ
­: number[]
========================================================================
*/
void
card_stock::count()
{
	int i;

	for(i=0; i<=14; i++) {
		number[i] = 0;
	}
	for(i=0; i<num; i++) {
		number[cards[i]->getnum()]++;
	}
}


