#ifndef _X_UTIL_H
#define _X_UTIL_H
#include <X11/Xlib.h>
#include <X11/Xutil.h>

extern Display* dis;  // Default Display
extern int scr;  // Default Screen
extern Window rootwin;
extern int screen_depth;  // screen depth

// γդ
extern unsigned long alloc_color(unsigned char red,
								 unsigned char green,
								 unsigned char blue);
// WTBեΥ
extern int loadWTB(Pixmap* pm,
				   Drawable vis,
				   char* fname, int* width, int* height);

// WTBեΥ(ΥѴ)
extern int loadWTBWithMono(Pixmap* pm,
						   Pixmap* mono,
						   Drawable vis,
						   char* fname, int* width, int* height);

// WTBեΥ(å׾դ)
extern int loadWTBWithClip(Pixmap* pm,
						   Pixmap* clip,
						   Drawable vis, char* fname, int* width, int* height,
						   int clip_color);

#endif
