/************************************************************************
̱cursesɽѥᥤ롼
***********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <curses.h>
#include "card.h"
#include "player.h"
#include "curs_player.h"

card_stock* stage;
card_stock* stock;
card_stock* drop;
curs_player** play;

#define NUGI_STAGES 7
#define YOU  3
#define NUGI 0

// ݥɽ
int opoint[5] = {-3, -1, 0, 1, 2};
// ɸݥɽ
int npoints [] = {6, 9, 14, 19, 26, 33, 42};
// ɽʸ
char* rank_string[] = {
	"v.poor",
	" poor ",
	" norm ",
	" rich ",
	"v.rich",
};
int point;  // ߤΥݥ
int cur_stage;  // æơ

/*
========================================================================
ǽ: 󥿥󥰤Ĥĥɥȥåɽ
: org_x = Ϥ
      org_y = 
	  width = Фƥ󥿥󥰤
	  s     = ɽ륫ɥȥå
: ʤ
­: 
========================================================================
*/
void
disp(int org_x, int org_y, int width, card_stock* s)
{
	int i, x, y;
	card* c;
	static char* nums   = " A 2 3 4 5 6 7 8 910 J Q KJO";
	static char* suites = "   H C D S";
	char buf[3];

	for(i=0; i<width; i++) {
		mvaddch(org_y, org_x+i, ' ');
	}
	for(i=0; i<width; i++) {
		mvaddch(org_y+1, org_x+i, ' ');
	}
	x = (width - s->getnum()*3)/2 + org_x;
	y = org_y;
	for(i=0; i<s->getnum(); i++) {
		c = s->show_card(i);
		strncpy(buf, &nums[(c->getnum() - 1)*2], 2);
		buf[2] = 0;
		mvaddstr(y, x, buf);
		strncpy(buf, &suites[c->getsuite()*2], 2);
		mvaddstr(y+1, x, buf);
		buf[2] = 0;
		x += 3;
	}
}


/*
========================================================================
ǽ: ʸΥ󥿥ɽ
: x,y   = ꥸ
      width = 󥿥
	  str   = ʸ
: ʤ
­: 
========================================================================
*/
void
center(int x, int y, int width, char* str)
{
	mvaddstr(y, (width - strlen(str))/2 + x, str);
}



/*
========================================================================
ǽ: ΰ֤õ
: x,y = 
      width = 
: ʤ
­: ʤ
========================================================================
*/
void
clear_line(int x, int y, int width)
{
	char buf[120];
	int i;

	for(i=0; i<width; i++) buf[i] = ' ';
	buf[i] = 0;
	mvaddstr(y, x, buf);
}


// ѿ
int state = 0, mode = 0;  // ơȥޥѥ
int st;  // ˥äץ쥤䡼
int at;  // ߤΥץ쥤䡼
int agari;  // ߤξ夬äƤͤοͿ
int started;  // κǽ餫ɤɽե饰(˥λФ˴Ϣ)

/*
========================================================================
ǽ: ɸѤΥơȥޥ
: ʤ
: 1ʤ⡼ɤʤ 0ʤ餳Υ⡼ɤΤޤ
­: 
========================================================================
*/
int
exchange()
{
	static int a, b;
	int i, ret;
	char buf[80];

	ret = 0;
	switch(state) {
	default:
	case 0:
		// ɬפʾäƤ
		for(i=0; i<5; i++) {
			play[i]->erase_turn();
			play[i]->erase_pass();
			play[i]->erase_init();
			play[i]->disp_hand();
			play[i]->disp_rank();
		}
		// ̱ٹƤ
		a = b = -1;
		for(i=0; i<5; i++) {
			if (play[i]->get_rank()==0) {
				a = i;
			}
			if (play[i]->get_rank()==4) {
				b = i;
			}
		}
		if (a==-1 || b==-1) {
			// ޤʤäϽ
			return 1;
		}
		// åν
		clear_line(0, 5, 40);
		clear_line(0, 6, 40);
		clear_line(0, 7, 40);
		sprintf(buf, "exchange v.poor(%d) <-> v.rich(%d)", a, b);
		center(0, 5, 40, buf);
		refresh();
		state++;
		break;
	case 1:
		// ɽ
		play[a]->disp_turn();
		refresh();
		state++;
		break;
	case 2:
		// ɰưɽ
		stage->add_card(play[a]->get_high());
		stage->add_card(play[a]->get_high());
		if (a==YOU || b==YOU) {
			disp(10, 6, 10, stage);
		} else {
			center(0, 6, 40, "]]");
		}
		play[a]->disp_hand();
		play[b]->disp_hand();
		refresh();
		state++;
		break;
	case 3:
		// ɤΰư
		play[b]->add_card(stage);
		clear_line(0, 6, 40);
		clear_line(0, 7, 40);
		// ɽ
		play[a]->erase_turn();
		play[b]->disp_turn();
		refresh();
		state++;
		break;
	case 4:
		// ɰưɽ
		stage->add_card(play[b]->get_lo());
		stage->add_card(play[b]->get_lo());
		if (a==YOU || b==YOU) {
			disp(10, 6, 10, stage);
		} else {
			center(0, 6, 40, "]]");
		}
		play[a]->disp_hand();
		play[b]->disp_hand();
		refresh();
		state++;
		break;
	case 5:
		// ɤΰư
		play[a]->add_card(stage);
		clear_line(0, 5, 40);
		clear_line(0, 6, 40);
		clear_line(0, 7, 40);
		play[a]->disp_hand();
		play[b]->disp_hand();
		// ɽ
		play[b]->erase_turn();
		// ̱,ٹθ
		for(i=0; i<5; i++) {
			if (play[i]->get_rank()==1) {
				a = i;
			}
			if (play[i]->get_rank()==3) {
				b = i;
			}
		}
		sprintf(buf, "exchange poor(%d) <-> rich(%d)", a, b);
		center(0, 5, 40, buf);
		refresh();
		state++;
		break;
	case 6:
		// ɽ
		play[a]->disp_turn();
		refresh();
		state++;
		break;
	case 7:
		// ɰưɽ
		stage->add_card(play[a]->get_high());
		if (a==YOU || b==YOU) {
			disp(10, 6, 10, stage);
		} else {
			center(0, 6, 40, "]");
		}
		play[a]->disp_hand();
		play[b]->disp_hand();
		refresh();
		state++;
		break;
	case 8:
		// ɤΰư
		play[b]->add_card(stage);
		clear_line(0, 6, 40);
		clear_line(0, 7, 40);
		// ɽ
		play[a]->erase_turn();
		play[b]->disp_turn();
		refresh();
		state++;
		break;
	case 9:
		// ɰưɽ
		stage->add_card(play[b]->get_lo());
		if (a==YOU || b==YOU) {
			disp(10, 6, 10, stage);
		} else {
			center(0, 6, 40, "]");
		}
		play[a]->disp_hand();
		play[b]->disp_hand();
		refresh();
		state++;
		break;
	case 10:
		// ɤΰư
		play[a]->add_card(stage);
		clear_line(0, 5, 40);
		clear_line(0, 6, 40);
		clear_line(0, 7, 40);
		play[a]->disp_hand();
		play[b]->disp_hand();
		ret = 1;
		break;
	}
	return ret;
}


/*
========================================================================
ǽ: ΤΥơȥޥ
: ʤ
: 1ʤ⡼ɤʤ 0ʤ餳Υ⡼ɤΤޤ
­: 
========================================================================
*/
int
player_think()
{
	int ret, i, n;

	ret = 0;
	switch(state) {
	case 0:
		// ֳȽɽ
		for(;;) {
			if (st==at) {
				// եå夷
				if (started) {
					drop->add_card(stage);
				} else {
					started = 1;
					for(i=0; i<5; i++) {
						play[i]->disp_hand();
					}
				}
				disp(10, 5, 10, stage);  // ơõ
				for(i=0; i<5; i++) {
					play[i]->erase_pass();
					play[i]->erase_init();
				}
				refresh();
				while (play[st]->getnum()==0) {
					st++;
					if (st==5) st = 0;
					at++;
					if (at==5) at = 0;
				}
			}
			if (play[at]->getnum()==0) {
				at++;
				if (at==5) at = 0;
				continue;
			} else {
				break;
			}
		}
		for(i=0; i<5; i++) {
			play[i]->erase_turn();
		}
		play[at]->disp_turn();
		refresh();
		state++;
		break;
	case 1:
		// ºݤνФư
		n = play[at]->think(agari, at, st, (player**)play, stage, stock);
		if (n) {
			disp(10, 5, 10, stage);
			if (n==2) {
				if (agari==0) {
					for(i=0; i<5; i++) {
						play[i]->erase_rank();
					}
				}
				play[at]->set_rank(4 - agari);
				play[at]->disp_rank();
				// play[at]->agari_disp();
				agari++;
				if (agari==4) {
					ret = 1;
					break;
				}
			}
			if (st!=-1) {
				play[st]->erase_init();
			}
			for(i=0; i<5; i++) {
				play[i]->erase_pass();
			}
			st = at;
			play[at]->disp_init();
			play[at]->disp_hand();
		} else {
			play[at]->disp_pass();
		}
		refresh();
		at++;
		if (at==5) at = 0;
		state = 0;
		break;
	}
	return ret;
}


/*
========================================================================
ǽ: 鸫ɽΥơȥޥ
: ʤ
: 1ʤ⡼ɤʤ 0ʤ餳Υ⡼ɤΤޤ
­: 
========================================================================
*/
int
kaomise()
{
	int ret = 0;
	switch(state) {
	case 0:
		play[4]->disp_turn();
		state++;
		break;
	case 1:
		play[4]->erase_turn();
		state++;
		break;
	case 2:
		play[0]->disp_turn();
		state++;
		break;
	case 3:
		play[0]->erase_turn();
		state++;
		break;
	case 4:
		play[1]->disp_turn();
		state++;
		break;
	case 5:
		play[1]->erase_turn();
		state++;
		break;
	case 6:
		play[2]->disp_turn();
		state++;
		break;
	case 7:
		play[2]->erase_turn();
		state++;
		ret = 1;
		break;
	}
	refresh();
	return ret;
}


/*
========================================================================
ǽ: ۥѥΥơȥޥ
: ʤ
: 1ʤ⡼ɤʤ 0ʤ餳Υ⡼ɤΤޤ
­: 
========================================================================
*/
int
haipai()
{
	int i;
	
	if (state==0) {
		stock->shuffle();
		// Ǻǽμͤ
		// 餬̤ʤࡣǤʤ̱
		st = at = -1;
		for(i=0; i<5; i++) {
			if (play[i]->get_rank()==0) {
				st = at = i;
				break;
			}
		}
		if (st==-1) {
			st = at = rand()%5;
		}
	}
	play[(st + state)%5]->add_card(stock->get_one());
	play[(st + state)%5]->disp_hand();
	refresh();
	if (++state==53) {
		return 1;
	} else {
		return 0;
	}
}


/*
========================================================================
ǽ: ɥ饤С
: ʤ
: ཪλʤ1, Ǥʤ0
­: mode / state˱ƥʹԤ
      ᥤ롼ϤΥ롼󤫤εͤ1ˤʤޤǸƤ³Ф
========================================================================
*/
int
driver()
{
	int ret, i;
	char buf[80];

	ret = 0;
	switch(mode) {
	case 0:
		// ɽν
		for(i=0; i<5; i++) {
			play[i]->disp_hand();
			play[i]->erase_turn();
		}
		refresh();
		
		state = 0;
		mode++;
		break;
	case 1:
		// 鸫
		if (kaomise()) {
			mode++;
		}
		break;
	case 2:
		// ݥɽ
		sprintf(buf, "now    POINT : %2d POINT", point);
		center(0, 5, 40, buf);
		sprintf(buf, "target POINT : %2d POINT", npoints[cur_stage]);
		center(0, 6, 40, buf);
		refresh();
		mode++;
		break;
	case 3:
		// ݥɽθ
		clear_line(0, 5, 40);
		clear_line(0, 6, 40);
		refresh();

		state = 0;
		mode++;
		break;
	case 4:
		// ۥѥ
		if (haipai()) {
			mode++;
			state = 0;
			agari = 0;
			started = 0;
		}
		break;
	case 5:
		// ɸ
		if (exchange()) {
			mode++;
			state = 0;
		}
		break;
	case 6:
		// ऽΤ
		if (player_think()) {
			mode++;
		}
		break;
	case 7:
		// θ
		for(i=0; i<5; i++) {
			if (play[i]->getnum()) {
				stock->add_card(play[i]);
				play[i]->set_rank(0);
				play[i]->disp_rank();
				play[i]->disp_hand();
				break;
			}
		}
		for(i=0; i<5; i++) {
			play[i]->disp_hand();
			play[i]->erase_turn();
		}

		// ݥɽ
		center(0, 5, 40, "POINT result");
		sprintf(buf, "YOU  : %s %2d POINT",
				rank_string[play[YOU]->get_rank()],
				opoint[play[YOU]->get_rank()]);
		center(0, 6, 40, buf);
		sprintf(buf, "NUGI : %s %2d POINT",
				rank_string[play[NUGI]->get_rank()],
				-opoint[play[NUGI]->get_rank()]);
		center(0, 7, 40, buf);
		point = point
			+ opoint[play[YOU]->get_rank()]
			- opoint[play[NUGI]->get_rank()] ;
		sprintf(buf, "Total %2d POINT", point);
		center(0, 8, 40, buf);
		refresh();
		mode++;
		break;
	case 8:
		if (point < 0) {  // ४СǤ
			attrset(A_REVERSE);
			center(0, 9, 40, "GAME OVER");
			attrset(A_NORMAL);
			refresh();
			mode += 2;
		}
		else if (point > npoints[cur_stage]) {
			center(0, 9, 40, "congraturation!!");
			refresh();
			cur_stage++;
			mode++;
		}
		else {
			mode += 2;
		}
		break;
	case 9:
		// æ
		mode++;
		break;
	case 10:
		// ݥɽθ
		clear_line(0, 5, 40);
		clear_line(0, 6, 40);
		clear_line(0, 7, 40);
		clear_line(0, 8, 40);
		clear_line(0, 9, 40);

		// ɲ
		stock->add_card(drop);
		stock->add_card(stage);
		if (stock->getnum()!=53) {  // ɲ?
			printf("error!");
			ret = 1;
		}
		else if (point < 0 || cur_stage==NUGI_STAGES) {
			ret = 1;
		}
		else {
			mode = 2;  // Ƭ
		}
		break;
	}
	return ret;
}


int main()
{
	initscr();
	point = 0;
	cur_stage = 0;
	srand((unsigned int)time(NULL));  // 
	stock = card_stock::gen_all();
	stage = new card_stock();
	drop  = new card_stock();
	play  = new curs_player*[5];
	play[0] = new curs_player(2, 0, "nugi");
	play[1] = new curs_player(22, 0, "neba");
	play[2] = new curs_player(25, 10, "kui");
	play[3] = new curs_user(0, 15, "you");
	play[4] = new curs_player(0, 10, "metan");

	mode = 0;
	while(driver()==0) {
		clock_t c;
		c = clock();
		while(clock() - c < CLOCKS_PER_SEC /4);  // ʤ
	}
	endwin();
}


