#ifndef _X_PLAYER_H
#define _X_PLAYER_H

#include "player.h"

class x_player : public player {
protected:
	int id;
	int tx, ty;
	int gx, gy;
	char *name;
	GC gc;
public:
	x_player(int id, int tx, int ty, int gx, int gy, char* name);
	virtual ~x_player();

	virtual void disp_face(Window win);
	virtual void disp_init(Window win);
	virtual void erase_face(Window win);
	void disp_name(Window win);
	void erase_name(Window win);
	virtual void disp_hand(Window win);
	virtual void disp_pass(Window win);
	virtual void erase_pass(Window win);
	virtual void disp_rank(Window win, int mode);
	virtual void erase_rank(Window win);
};


#endif
