#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "x_player.h"
#include "x_util.h"
#include "text.h"
#include "dhm.h"

/*
========================================================================
ǽ: 껥ɽ
: win = Window
: ʤ
­: 98СȰ㤤󥿥󥰤ɽ
========================================================================
*/
void
x_user::disp_hand(Window win)
{
	int w, ox, i, n;
	
	w = (CARD_X-8)*(11 - 1) + CARD_X;
	ox = (640 - w)/2;
	XCopyArea(dis, waku, win, gc, 
			  ox, HAND_ORG_Y, (CARD_X-8)*10 +CARD_X, CARD_Y,
			  ox, HAND_ORG_Y);
	if (num > 9) {
		w = (CARD_X-8)*(num - 1) + CARD_X;
		ox = (640 - w)/2;
		for(i=0; i<num; i++) {
			if (cards[i]->getnum()==14) {
				n = 52;
			} else {
				n = (cards[i]->getsuite()-1)*13 + (cards[i]->getnum()-1);
			}
			XCopyArea(dis, 
					  card_pix[n],
					  win,
					  gc,
					  0, 0, CARD_X, CARD_Y,
					  ox + (CARD_X-8)*i, HAND_ORG_Y);
		}
	} else {
		w = CARD_X*num;
		ox = (640 - w)/2;
		for(i=0; i<num; i++) {
			if (cards[i]->getnum()==14) {
				n = 52;
			} else {
				n = (cards[i]->getsuite()-1)*13 + (cards[i]->getnum()-1);
			}
			XCopyArea(dis,
					  card_pix[n],
					  win,
					  gc, 
					  0, 0, CARD_X, CARD_Y,
					  ox + CARD_X*i, HAND_ORG_Y);
		}
	}
}


/*
========================================================================
ǽ: ѥɽ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_user::disp_pass(Window win)
{
	unsigned long red;
	
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  (tx+8)*8, (ty-1)*16, 8*4, 16,
			  (tx+8)*8, (ty-1)*16);
	red = alloc_color(0xff, 0, 0);
	set_text_mode(TEXT_TRANSPARENT);
	set_text_color(red);
	draw_string(win, (tx+8)*8, (ty-1)*16, "Ѥ");
}


/*
========================================================================
ǽ: ѥξõ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_user::erase_pass(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  (tx+8)*8, (ty-1)*16, 8*4, 16,
			  (tx+8)*8, (ty-1)*16);
}


/*
========================================================================
ǽ: ξõ
: win = Window
: ʤ
­: ̤˴餬ɽ櫓ǤϤʤñ˥ɽõΤ
========================================================================
*/
void
x_user::erase_face(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  (tx+14)*8, (ty-1)*16, 8*10, 16,
			  (tx+14)*8, (ty-1)*16);
}


/*
========================================================================
ǽ: ξõ
: win = Window
: ʤ
­: ̤˴餬ɽ櫓ǤϤʤ
      롼̾碌ƤΤǤΤ褦̾ˤʤä
	  ɽ򤹤
========================================================================
*/
void
x_user::disp_face(Window win)
{
	unsigned long blue;
	
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  (tx+14)*8, (ty-1)*16, 8*10, 16,
			  (tx+14)*8, (ty-1)*16);
	blue = alloc_color(0, 0, 0xff);
	set_text_mode(TEXT_FILL);
	set_text_color(WhitePixel(dis,scr));
	set_text_back_color(blue);
	draw_string(win, (tx+14)*8, (ty-1)*16, "ʤ");
}


/*
========================================================================
ǽ: ˥ɽ
: win = Window
: ʤ
­: Ȼ
========================================================================
*/
void
x_user::disp_init(Window win)
{
	// äȤȥå
	// 桼ξ,ʬΥɤǤ뤳Ȥɽɬפ̵Τ
	// ǥɽä
	erase_face(win);
}


/*
========================================================================
ǽ: ˥ɤ֤
: n = ֹ(1-14)
      m = 
	  stage = 
	  drop  = Τƾ
: ʤ
­: class playerset_cardȤ̤ʤΤ
========================================================================
*/
void
x_user::set_card(int n, int m, card_stock* stage, card_stock* drop)
{
	int i;
	
	drop->add_card(stage);
	for(i=0; i<m; i++) {
		stage->add_card(get_card(n));
	}
}



/*
========================================================================
ǽ: ɽ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_user::disp_rank(Window win, int mode)
{
	unsigned long red, blue;
	
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  tx*8, (ty-1)*16, 8*6, 16,
			  tx*8, (ty-1)*16);
	if (rank!=-1) {
		red = alloc_color(0xff, 0, 0);
		blue = alloc_color(0, 0, 0xff);
		set_text_mode(TEXT_TRANSPARENT);
		if (mode==0) {
			set_text_color(blue);
		} else {
			set_text_color(red);
		}
		draw_string(win, tx*8, (ty-1)*16, rk[rank]);
	}
}


/*
========================================================================
ǽ: ξõ
: win = Window
: ʤ
­: 
========================================================================
*/
void
x_user::erase_rank(Window win)
{
	XCopyArea(dis,
			  waku,
			  win,
			  gc, 
			  tx*8, (ty-1)*16, 8*6, 16,
			  tx*8, (ty-1)*16);
}



